import es
import playerlib
import vecmath
import gamethread
import effectlib
from mcolormsglib import mcolormsg
import random

npcs = ['gman', 'dog', 'alyx', 'barney', 'antlion', 'antlionguard', 'breen', 'combine_camera', 'crow', 'cscanner', 'eli', 'headcrab', 'headcrabfast', 'kleiner', 'manhack', 'monk', 'pigeon', 'rollermine', 'seagull', 'strider', 'vortigaunt', 'turret_floor', 'turret_ceiling']

nodelete = ['world', 'info_player_start', 'info_player_deathmatch', 'info_player_rebel', 'info_player_combine', 'worldspawn', 'player', 'team_manager']

es.keygroupload('props', '|propspawn')

es.keygroupload('playersaves', '|propspawn')
if es.keygetvalue('playersaves', 'def', 'save'): None
else:
	es.keygroupcreate('playersaves')
	es.keycreate('playersaves', 'def')
	es.keysetvalue('playersaves', 'def', 'save', '1')
	es.keygroupsave('playersaves', '|propspawn')
es.keygroupload('propsaves', '|propspawn')
if es.keygetvalue('propsaves', 'def', 'save'): None
else:
	es.keygroupcreate('propsaves')
	es.keycreate('propsaves', 'def')
	es.keysetvalue('propsaves', 'def', 'save', '1')
	es.keygroupsave('propsaves', '|propspawn')
	
def unload():
	es.keygroupdelete('propsaves')
	es.keygroupdelete('playersaves')
	
def player_activate(ev):
	entity.playerCheck(ev['userid'])

def player_spawn(ev):
	playerlib.getPlayer(ev['userid']).color = entity.getPlayerColor(ev['userid'])
	

class entity():
			
	def deleteProp(self, userid, all):
		if all == 1:
			props = 0
			for prop in self.owner:
				if self.owner[prop] == es.getplayersteamid(userid):
					if es.entitygetvalue(prop, 'classname'):
						props += 1
						es.remove(prop)
			notify(userid, '%s props removed'%props)
		else:
			es.sexec(userid, 'ent_delete')
			x,y,z = playerlib.getPlayer(userid).location
			x2,y2,z2 = str(playerlib.getPlayer(userid).viewcoord).split(",")
			effectlib.drawLine((x,y,z), (x2,y2,z2), 'materials/sprites/laser.vmt', 'materials/sprites/halo01.vmt', 1, 10, 10, self.playerColor[int(userid)][0], self.playerColor[int(userid)][1], self.playerColor[int(userid)][2], 255, 100, 0, 0, 0, 0)
		
	def spawnNPC(self, userid, item):
		if self.vars['allow_build'] == 1:
			if item in npcs:
				index = es.createentity('npc_%s'%item)
				coord = str(playerlib.getPlayer(userid).viewcoord).replace(",", " ")
				es.entitysetvalue(index, 'origin', coord)
				es.spawnentity(index)
			else: notify(userid, 'cannot spawn that npc')
				
	def spawnItem(self, userid, item):
		if self.vars['allow_build'] == 1:
			item_check = es.keygetvalue('props', item, 'model')
			if item_check:
				indexphysics = es.createentity('prop_physics')
				self.propmodel[indexphysics] = 'models/%s'%item_check
				es.entitysetvalue(indexphysics, 'model', 'models/%s'%item_check)
				es.entitysetvalue(indexphysics, 'solid', '2')
				es.entitysetvalue(indexphysics, 'classname', 'prop_%s'%userid)
				coord = str(playerlib.getPlayer(userid).viewcoord).replace(",", " ")
				es.entitysetvalue(indexphysics, 'origin', coord)
				es.spawnentity(indexphysics)
				es.fire(userid, 'prop_%s'%userid, 'disablemotion')
				for x in es.createentitylist():
					if es.entitygetvalue(x, 'classname') == 'prop_%s'%userid:
						self.owner[x] = es.getplayersteamid(userid)
						es.fire(userid, 'prop_%s'%userid, 'addoutput', 'classname prop_physics')
			else: notify(userid, 'prop not found in database!')

entity = entity()

def delete():
	if es.getargs() == 'all': entity.deleteProp(es.getcmduserid(), 1)
	else: entity.deleteProp(es.getcmduserid(), 0)
es.regsaycmd('!del', 'propspawn/delete')

def spawn(): entity.spawnItem(es.getcmduserid(), es.getargs())
es.regsaycmd('!s', 'propspawn/spawn')

def npc(): entity.spawnNPC(es.getcmduserid(), es.getargs())
es.regsaycmd('!npc', 'propspawn/npc')

for i in es.getUseridList():
	entity.playerCheck(i)
	entity.setPlayerColor(i)